package fi.gurnarok.timer;

import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.Timer;


public class DigitalClock extends JFrame implements ActionListener 
{
	private static final long serialVersionUID = -4537527976233430167L;
	JLabel timeLabel = new JLabel();
	int seconds = 0;
	int minutes = 0;
	int hours = 0;
	Timer timer;
	
	public DigitalClock()
	{
		super("Timer");
		
		this.setLayout(new GridLayout(2,1));
		
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		timeLabel.setText(String.format("%02d:%02d:%02d",hours,minutes,seconds));
		timeLabel.setFont(new Font("Dialog",Font.PLAIN,96));
		
		timer = new Timer(1000,this);
		timer.setRepeats(true);
		
		JPanel buttons = new JPanel();
		
		JButton start = new JButton("Start");
		start.setActionCommand("START");
		start.addActionListener(this);
		
		JButton stop = new JButton("Stop");
		stop.setActionCommand("STOP");
		stop.addActionListener(this);
		
		
		JButton reset = new JButton("Reset");
		reset.setActionCommand("RESET");
		reset.addActionListener(this);
		
		buttons.setLayout(new GridLayout(1, 3));
		buttons.add(start);
		buttons.add(stop);
		buttons.add(reset);
		
		this.add(timeLabel);
		this.add(buttons);
		this.pack();
		this.setVisible(true);
	}
	
	@Override
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource().equals(timer))
		{
			seconds++;
			if(seconds>59)
			{
				seconds = 0;
				minutes++;
			}
			
			if(minutes>59)
			{
				minutes = 0;
				hours++;
			}
			
			timeLabel.setText(String.format("%02d:%02d:%02d",hours,minutes,seconds));
		}
		else
		{
			String cmd = e.getActionCommand();
			if(cmd=="START")
			{
				timer.start();
			}
			else if(cmd=="STOP")
			{
				timer.stop();
			}
			else if(cmd=="RESET")
			{
				hours = minutes = seconds = 0;
				timeLabel.setText(String.format("%02d:%02d:%02d",hours,minutes,seconds));
				timer.stop();
			}
			else
			{
				System.out.println("Unknown command");
			}
		}
	}
	
	public static void main(String[] args)
	{
		new DigitalClock();
	}
}
